VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form frmGrpCalInit 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Group Calendar"
   ClientHeight    =   4050
   ClientLeft      =   1590
   ClientTop       =   3495
   ClientWidth     =   6555
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   Picture         =   "GroupCalendarInit.frx":0000
   ScaleHeight     =   4050
   ScaleWidth      =   6555
   ShowInTaskbar   =   0   'False
   Begin ComctlLib.ProgressBar pbrItems 
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   6375
      _ExtentX        =   11245
      _ExtentY        =   450
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "CMR International Diary"
      BeginProperty Font 
         Name            =   "Futura Light"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00800080&
      Height          =   375
      Left            =   3360
      TabIndex        =   3
      Top             =   3600
      Width           =   3015
   End
   Begin VB.Label lblStatus 
      BackStyle       =   0  'Transparent
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00800080&
      Height          =   225
      Left            =   1050
      TabIndex        =   1
      Top             =   945
      Width           =   5370
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Please wait:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   120
      TabIndex        =   0
      Top             =   945
      Width           =   960
   End
End
Attribute VB_Name = "frmGrpCalInit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'**Group Calendar**
'Rick Eveleigh (c) 1994-1998
'reveleigh@cmr.org
'CMR International
'Woodmansterne Road, Carshalton, Surrey SM5 4DS. UK
'http://www.cmr.org/
'last update 02-Feb-98

Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

Private Sub Form_Load()
    
  '--Problems to be fixed:
  '  * Recurring appts where one of the events
  '    is moved (eg every Thursday, one gets moved to Monday still
  '    displays on Thursday
  
  On Error GoTo Err_Form_Load
  
  frmGrpCalInit.Show
  
  Dim ootlApp As Object
  Dim ootlMAPI As NameSpace
  Dim ootlCalendar As Object
  Dim ootlItems As Object
  Dim ootlAppt As Object
  Dim ootlUser As Object
  Dim ootlRecur As Object
  Dim strInitials As String
  Dim strDiary As String
  Dim strProfileName As String
  Dim strRestrict As String
  Dim strTempPath As String
  Dim ilngLoop As Long
  Dim lngDayCount As Long
  Dim intInterval As Integer
  Dim lngOccurrences As Long
  Dim dtmApptStart As Date
  Dim dtmApptEnd As Date
  Dim strApptText As String
  Dim wspCurr As Workspace
  Dim dbsCurr As Database
  Dim tdfCurr As TableDef
  Dim rstCurr As Recordset
  Dim dtmWork As Date
  Dim strInterval As String
  Dim lngRet As Long
  Dim dbsUsers As Database
  Dim rstUsers As Recordset
  Dim strEMail As String
  Dim omapiApp As MAPI.Session
  Dim omapiAddrList As Object
  Dim omapiAddrEntries As Object
  Dim omapiAddrEntry As Object
  Const HKEY_CURRENT_USER = &H80000001
  Dim lnghKey As Long
  Dim lngBuffer As Long
  Dim lngType As Long
  Dim intItemCurr As Integer
  Dim blnIsRecurring As Boolean
    
  strTempPath = Environ("Temp")
  
  On Error Resume Next
    Kill strTempPath & "\Group Calendar.mdb"
  On Error GoTo Err_Form_Load
    
  '--hourglass on
  Screen.MousePointer = vbHourglass
  
  '--Create the database, table and fields
  lblStatus.Caption = "Creating temporary file"
  Set wspCurr = DBEngine.Workspaces(0)
  Set dbsCurr = wspCurr.CreateDatabase(strTempPath & "\Group Calendar.mdb", dbLangGeneral)
  Set tdfCurr = dbsCurr.CreateTableDef("tblDiaryTemp")
  
  With tdfCurr
    .Fields.Append .CreateField("Start", dbDate)
    .Fields.Append .CreateField("End", dbDate)
    .Fields.Append .CreateField("Name", dbText, 5)
    .Fields.Append .CreateField("Title", dbText, 250)
    .Fields.Append .CreateField("BusyStatus", dbByte)
    .Fields.Append .CreateField("Location", dbText, 50)
    .Fields.Append .CreateField("IsRecurring", dbBoolean)
    .Fields.Append .CreateField("Recurrence", dbByte)
    .Fields.Append .CreateField("Instance", dbLong)
    .Fields.Append .CreateField("Interval", dbLong)
  End With
  dbsCurr.TableDefs.Append tdfCurr
  tdfCurr.Fields("Title").AllowZeroLength = True
  tdfCurr.Fields("Location").AllowZeroLength = True
  Set rstCurr = dbsCurr.OpenRecordset("tblDiaryTemp")
    
  '--open OLE Outlook
  lblStatus.Caption = "Opening link to Outlook"
  lblStatus.Refresh
  Set ootlApp = CreateObject("Outlook.Application")

  '--open MAPI Session
  Set omapiApp = CreateObject("MAPI.Session")
  '--get the name of the default profile
  strProfileName = RegGetString(HKEY_CURRENT_USER _
    , "Software\Microsoft\Windows Messaging Subsystem\Profiles" _
    , "DefaultProfile")
  omapiApp.Logon ProfileName:=strProfileName
   
  '--open Global Address Book
  For ilngLoop = 1 To omapiApp.AddressLists.Count
    If omapiApp.AddressLists(ilngLoop) = "Global Address List" Then
      Set omapiAddrList = omapiApp.AddressLists(ilngLoop)
      Exit For
    End If
  Next
  
  '--Loop through the users
  For Each omapiAddrEntry In omapiAddrList.AddressEntries
  '--Skip Groups
    If omapiAddrEntry.DisplayType = 1 Then GoTo NextUser
  '--open the user's Outlook calendar
    Set ootlMAPI = ootlApp.GetNamespace("MAPI")
    Set ootlUser = ootlMAPI.CreateRecipient(omapiAddrEntry)
    ootlUser.Resolve
    Set ootlCalendar = ootlMAPI.GetSharedDefaultFolder _
      (ootlUser, olFolderCalendar)
  '--set filter for today and later or recurring
    strRestrict = "([Start] >= """ & Date _
      & """ Or [IsRecurring] = ""-1"") And [BusyStatus] > 0"
    ootlCalendar.Items.IncludeRecurrences = True
  '--make this subset
    Set ootlItems = ootlCalendar.Items.Restrict(strRestrict)
    lblStatus.Caption = "Reading " & omapiAddrEntry & "'s Calendar (" _
      & ootlItems.Count & "/" & ootlCalendar.Items.Count & ")"
    pbrItems.Value = 0
    lblStatus.Refresh
  '--custom attribute 1 holds the initials
    strInitials = omapiAddrEntry.Fields(-2144534498)
    intItemCurr = 1
    pbrItems.Min = 0
    pbrItems.Max = ootlItems.Count
    
    For Each ootlAppt In ootlItems
  '--Make text 'private appt' if appt is private
      pbrItems.Value = intItemCurr
      If ootlAppt.Sensitivity = olPrivate Then
        strApptText = "private appointment"
      Else
        strApptText = ootlAppt
      End If
  
  '--JF/LS is a jobshare. They have been told to put their own initials
  '  at the beginning of the appt if it's individual
      If strInitials = "JF/LS" Then
        If Left(strApptText, 2) = "JF" Or Left(strApptText, 2) = "LS" Then
          strInitials = Left(strApptText, 2)
          strApptText = Mid(strApptText, 4)
        End If
      End If
      
      blnIsRecurring = ootlAppt.IsRecurring
      dtmApptStart = ootlAppt.Start
      dtmApptEnd = ootlAppt.End
  '--If the time of the end date is 00:00:00 then make the date one day less
      If TimeValue(dtmApptEnd) = 0 Then dtmApptEnd = dtmApptEnd - 1
      
  '--For non-recurring Appts (easy bit!)
      If Not blnIsRecurring Then
  '--Single entry for single day Appt (easiest bit!)
        lngDayCount = DateValue(dtmApptEnd) - DateValue(dtmApptStart)
        If lngDayCount = 0 Then
          With rstCurr
            .AddNew
            !Start = dtmApptStart
            !End = dtmApptEnd
            !Name = strInitials
            !Title = Left(strApptText, 250)
            !BusyStatus = ootlAppt.BusyStatus
            !Location = IIf(strApptText = "private appointment" _
              , "", Left(ootlAppt.Location, 50))
            .Update
          End With
  '--Multiple entries for multi-day Appts
        Else
          For ilngLoop = 0 To lngDayCount
            With rstCurr
              .AddNew
              !Start = DateValue(dtmApptStart) + ilngLoop _
                + IIf(ilngLoop = 0, TimeValue(dtmApptStart), 0)
              !End = DateValue(dtmApptStart) + ilngLoop _
                + IIf(ilngLoop = lngDayCount, TimeValue(dtmApptEnd), 0)
              !Name = strInitials
              !Title = Left(strApptText, 250)
              !BusyStatus = ootlAppt.BusyStatus
              !Location = IIf(strApptText = "private appointment" _
                , "", Left(ootlAppt.Location, 50))
              .Update
            End With
          Next ilngLoop
        End If
  
  '--Recurring Appts
      Else
        Set ootlRecur = ootlAppt.GetRecurrencePattern
  '--Make seperate records if there is an end date to the pattern
        If Not ootlRecur.NoEndDate Then
          Select Case ootlRecur.RecurrenceType
            Case 0    'daily
              strInterval = "d"
            Case 1    'weekly
              strInterval = "ww"
            Case 2, 3 'monthly
              strInterval = "m"
            Case 5, 6 'yearly
              strInterval = "yyyy"
          End Select
          intInterval = ootlRecur.Interval
  '--some recurring entries are in this format
          If ootlRecur.StartTime = #1/1/1601# Then
            lngOccurrences = ootlRecur.PatternEndDate - ootlRecur.PatternStartDate - 1
          Else
            lngOccurrences = ootlRecur.Occurrences - 1
          End If
  '--if the final occurrence is today or later, write the entries
          If DateAdd(strInterval, lngOccurrences * intInterval, dtmApptEnd) >= Date Then
            For ilngLoop = 0 To lngOccurrences
              With rstCurr
                .AddNew
                !Start = DateAdd(strInterval, ilngLoop * intInterval, dtmApptStart)
                !End = DateAdd(strInterval, ilngLoop * intInterval, dtmApptEnd)
                !Name = strInitials
                !Title = Left(strApptText, 250)
                !BusyStatus = ootlAppt.BusyStatus
                !Location = IIf(strApptText = "private appointment" _
                  , "", Left(ootlAppt.Location, 50))
                .Update
              End With
            Next ilngLoop
          End If
  '--Make one record for indefinite recurring Appts
        Else
          With rstCurr
            .AddNew
            !Start = dtmApptStart
            !End = IIf(TimeValue(dtmApptEnd) = 0, dtmApptEnd - 1, dtmApptEnd)
            !Name = strInitials
            !Title = Left(strApptText, 250)
            !BusyStatus = ootlAppt.BusyStatus
            !Location = IIf(strApptText = "private appointment" _
              , "", Left(ootlAppt.Location, 50))
            !IsRecurring = True
            !Recurrence = ootlRecur.RecurrenceType
            !Instance = ootlRecur.Instance
            !Interval = ootlRecur.Interval
            .Update
          End With
        Set ootlRecur = Nothing
        End If
      End If
      
      Set ootlAppt = Nothing
      intItemCurr = intItemCurr + 1
    Next ootlAppt
        
    Set ootlItems = Nothing
    Set ootlCalendar = Nothing
NextUser:
  Next omapiAddrEntry

  frmGroupCalendar.Show

Exit_Form_Load:
  Set rstCurr = Nothing
  Set dbsCurr = Nothing
  Set wspCurr = Nothing
  Screen.MousePointer = vbDefault
  Exit Sub
  
Err_Form_Load:
  If Err.Number = -2147221233 Then  '--no Calendar for user or Permissions not set
    Debug.Print ootlUser
    Resume NextUser
  Else
    MsgBox "Error: " & Err.Number & " " & Err.Description
    Me.Visible = False
    Resume Exit_Form_Load
  End If

End Sub

Function RegGetString(lnghKey As Long, ByVal strSubKey As String _
 , ByVal strValueName As String) As String

  '--Taken from the Microsoft Knowledge Base
  
  Dim strWork As String
  Dim lnghSubKey As Long
  Dim lngType As Long
  Dim lngSZ As Long
  Dim lngRtn As Long
  Dim strValue As String
  
  strWork = ""
  Const KEY_ALL_ACCESS As Long = &HF0063
  Const ERROR_SUCCESS As Long = 0
  Const REG_SZ As Long = 1
  
  lngRtn = RegOpenKeyEx(lnghKey, strSubKey, 0, KEY_ALL_ACCESS _
    , lnghSubKey)
  If lngRtn <> ERROR_SUCCESS Then GoTo QuitNow
  lngSZ = 256
  strValue = String(lngSZ, 0)
  lngRtn = RegQueryValueEx(lnghSubKey, strValueName, 0, lngType _
    , ByVal strValue, lngSZ)
  If lngRtn = ERROR_SUCCESS And lngType = REG_SZ Then _
    strWork = Left(strValue, lngSZ)
  If lnghKey = 0 Then lngRtn = RegCloseKey(lnghSubKey)
  
QuitNow:
  RegGetString = strWork
  
End Function

